require "sentra/version"
require 'sinatra/base'

require 'sinatra'
require 'trinidad'
require 'json'
require 'sentra/opr'
require 'sentra/rest_client'
require "sentra/sents"
require 'securerandom'
require 'yaml'
require "rack-timeout"


module Sentra
  # Your code goes here...

  puts "Hello, gem "
  class SentraService < Sinatra::Base

    configure do

      config_path = Dir.pwd + "/config.yml"
      p config_path
      if File.exists? config_path
        topolog_settings = YAML.load_file config_path
        puts 'Config file exists and read'
      else
        topolog_settings = {}
        topolog_settings['parallelism'] = 4
        topolog_settings['timeout'] = 1000000000000
        puts 'Config file does not exist parallelism set to 3'
      end
      p topolog_settings

      drpc = StormDRPC::SentraDrpcTopology.createLocalDrpcCluster( topolog_settings['parallelism'].to_i)
      set :server, :trinidad
      set :bind, '0.0.0.0'
      set :drpc, drpc
      set :timeout,  topolog_settings['timeout']


    end

    use Rack::Timeout
    Rack::Timeout.timeout = 100000000
    Rack::Utils.key_space_limit = 30000000

    before do
      content_type :json
      headers 'Access-Control-Allow-Origin' => '*',
              'Access-Control-Allow-Methods' => ['OPTIONS', 'GET', 'POST', 'PUT'],
              'Access-Control-Allow-Headers' => ['Origin', 'X-Requested-With', 'Content-Type', 'Accept']
    end


    post '/sentra/analyzer/batch' do

      query = request.body.read.to_s

      settings.drpc.execute("computeProductSum", query)


    end


    run!
  end
end
