require_relative ENV['OPR_JAR'] + "/opr-nlp-pipeline-jar-with-dependencies.jar"
require_relative ENV['OPR_JAR']+ "/junixsocket-1.3.jar"

module HyperLastic
  include_package "crriskdata.opr.hyperelastic"
  import "crriskdata.opr.hyperelastic"

end

module OprData
  include_package "crriskdata.opr.data"
  import "crriskdata.opr.data"

end

module Net
  include_package "java.net"
  import "java.net"
end

module Util
  include_package "java.util"
  import "java.util"
end

module Text
  include_package "java.text"
  import "java.text"
end

module SemanticService
  include_package "crriskdata.opr.nlp.storm.rabbitmq"
  import "crriskdata.opr.nlp.storm.rabbitmq"

end

module Storm
  include_package "crriskdata.opr.nlp.storm"
  import "crriskdata.opr.nlp.storm"
end

module StormDRPC
  include_package "crriskdata.opr.nlp.storm.drpc"
  import "crriskdata.opr.nlp.storm.drpc"
end

module StormDrpcTopology
  include_package "crriskdata.opr.nlp.storm.rabbitmq"
  import "crriskdata.opr.nlp.storm.rabbitmq"
end


module ArticleTools
  class ArticleSerializer
    def initialize
      @simpleFormat = OprData::SimpleFormat.new(OprData::Article)
    end

    def write_to_xml_string article

      out = java.io.ByteArrayOutputStream.new()
      @simpleFormat.format(out, article)
      out.close()
      out.toString("UTF-8")
    end

    def read_from_xml_string str
      java_str = java.lang.String.new(str)
      input = java.io.ByteArrayInputStream.new(java_str.getBytes("UTF-8"))
      @simpleFormat.parse(input)
    end
  end
end

def prepare_article content, url, title, domain='GENERAL'
  tweet = OprData::Article.new

  calendar = Util::Calendar.getInstance();
  tweet.setUrl(Net::URL.new(url));
  tweet.setDate(calendar.getTime)
  tweet.setTitle(title)
  tweet.setChannel(domain)
  tweet.setContent(content)
  tweet
end


def process_result statistics
  response = {}
  # puts 'here statistics'
  # p statistics
  if statistics[3].getValue.to_f > 0
    response['negative'] = statistics[0].getValue.to_f / statistics[3].getValue.to_f
    response['positive'] = statistics[1].getValue.to_f / statistics[3].getValue.to_f
    response['neutral'] = statistics[2].getValue.to_f / statistics[3].getValue.to_f

  else
    response['negative'] = 0
    response['positive'] = 0
    response['neutral'] = 1

  end
  response['details'] = {}
  response
end