require 'tools_helper'

class CheckBatch
  def initialize id, host='localhost:4567'
    @id=id
    mycsv = CSV_MODULE::MyCSV.new('auxillary/testdata.csv')
    @queries = mycsv.get_queries
    @iterations = 400
    @url = "http://#{host}/sentra/analyzer/batch"
  end

  def call
    puts 'STARTED THREAD NUMBER: ' + @id.to_s

    r = Random.new

    batch_query = []

    @iterations.times do |time|
      q = {}
      q['content'] = @queries[r.rand(0..490)]['content']
      batch_query.push q
    end


    response = RestClient2.post(@url, batch_query.to_json)

    json = JSON.parse(response.body)
    p json

  end
end



num_threads = 1
host = '10.1.2.230:4567'

tasks = []
executor = ThreadPoolExecutor.new(num_threads, # core_pool_treads
                                  num_threads + 10, # max_pool_threads
                                  60, # keep_alive_time
                                  TimeUnit::SECONDS,
                                  LinkedBlockingQueue.new)


num_threads.times do |i|
  crawler = CheckBatch.new(i) do |selff|
  end

  task = FutureTask.new(crawler)
  executor.execute(task)
  tasks << task
end

tasks.each do |t|
  t.get
end

executor.shutdown()