java_import 'java.util.concurrent.Callable'
java_import 'java.util.concurrent.FutureTask'
java_import 'java.util.concurrent.LinkedBlockingQueue'
java_import 'java.util.concurrent.ThreadPoolExecutor'
java_import 'java.util.concurrent.TimeUnit'

require 'sentra/rest_client'
require "sentra/sents"


num_threads = 20
host = '5.9.118.83'
namespace = 'consolidation'

tasks = []

contents = ["Never try.", "It goes down the drain", "The service was good, but coffee was bad", "Sony Inc is a good company"]


class CheckLoad
  def initialize id, contents
    @id=id
    @contents = contents
    mycsv = CSV_MODULE::MyCSV.new('auxillary/testdata.csv')
    @queries = mycsv.get_queries
  end

  def call
    puts 'STARTED THREAD NUMBER: ' + @id.to_s

    r = Random.new
    @queries.each_with_index do |query, index|
      q = {}
      #q['content'] = query['content']
      q['content'] = @queries[r.rand(0..490)]['content']
      puts "QUERY TO SEND: '" + q['content'] + "'"

      url = "http://10.1.2.230:4567/sentra/analyzer/atomic?key=QD3F7Yr2u098RfaB"
      response = RestClient2.post(url, q.to_json)

      json = JSON.parse(response.body)
      puts "RECEIVED RESPONSE FROM THREAD: " + @id.to_s + " FOR CONTENT  '" + q['content'] + "' RESULT: " +
               json.to_s
    end
  end
end


executor = ThreadPoolExecutor.new(20, # core_pool_treads
                                  30, # max_pool_threads
                                  60, # keep_alive_time
                                  TimeUnit::SECONDS,
                                  LinkedBlockingQueue.new)


num_threads.times do |i|
  crawler = CheckLoad.new(i, contents) do |selff|

  end
  task = FutureTask.new(crawler)
  executor.execute(task)
  tasks << task
end

tasks.each do |t|
  t.get
end

executor.shutdown()
